Package org.apache.sysds.runtime.matrix.data

## Class DnnParameters

- java.lang.Object
- - org.apache.sysds.runtime.matrix.data.DnnParameters

- All Implemented Interfaces:
    `Serializable`

      public class DnnParameters
      extends Object
      implements Serializable

  This class is container that stores parameters required for executing following operations: conv2d, conv2d_backward_data, conv2d_backward_filter, maxpooling, maxpooling_backward
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `MatrixBlock` | `bias` |
    `int` | `C` |
    `boolean` | `enableNative` |
    `int[]` | `end_indexes_h` |
    `int[]` | `end_indexes_w` |
    `int` | `H` |
    `MatrixBlock` | `input1` |
    `MatrixBlock` | `input2` |
    `int` | `K` |
    `double` | `minValForMaxPoolOperations` |
    `int` | `N` |
    `int` | `numThreads` |
    `MatrixBlock` | `output` |
    `int` | `P` |
    `int` | `pad_h` |
    `int` | `pad_w` |
    `int` | `Q` |
    `int` | `R` |
    `int` | `S` |
    `int[]` | `start_indexes_h` |
    `int[]` | `start_indexes_w` |
    `int` | `stride_h` |
    `int` | `stride_w` |
    `int` | `W` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DnnParameters​(int N, int C, int H, int W, int K, int R, int S, int stride_h, int stride_w, int pad_h, int pad_w, int numThreads)` |
    `DnnParameters​(long N, long C, long H, long W, long K, long R, long S, long stride_h, long stride_w, long pad_h, long pad_w, int numThreads)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `compare​(DnnParameters that)` |
    `boolean` | `isAllOnes​(Integer... params)` |
    `boolean` | `isOutputThreadSafe()` |
    `boolean` | `isStride1Pad0()` |
    `void` | `setIfUnknown​(Hop N, Hop C, Hop H, Hop W, Hop K, Hop R, Hop S, Hop stride_h, Hop stride_w, Hop pad_h, Hop pad_w, int numThreads)` |
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### N

          public int N

    - #### C

          public int C

    - #### H

          public int H

    - #### W

          public int W

    - #### K

          public int K

    - #### R

          public int R

    - #### S

          public int S

    - #### P

          public int P

    - #### Q

          public int Q

    - #### stride_h

          public int stride_h

    - #### stride_w

          public int stride_w

    - #### pad_h

          public int pad_h

    - #### pad_w

          public int pad_w

    - #### numThreads

          public int numThreads

    - #### enableNative

          public boolean enableNative

    - #### input1

          public MatrixBlock input1

    - #### input2

          public MatrixBlock input2

    - #### output

          public MatrixBlock output

    - #### bias

          public MatrixBlock bias

    - #### start_indexes_h

          public int[] start_indexes_h

    - #### end_indexes_h

          public int[] end_indexes_h

    - #### start_indexes_w

          public int[] start_indexes_w

    - #### end_indexes_w

          public int[] end_indexes_w

    - #### minValForMaxPoolOperations

          public double minValForMaxPoolOperations

  - ### Constructor Detail

    - #### DnnParameters

          public DnnParameters​(long N,
                               long C,
                               long H,
                               long W,
                               long K,
                               long R,
                               long S,
                               long stride_h,
                               long stride_w,
                               long pad_h,
                               long pad_w,
                               int numThreads)

    - #### DnnParameters

          public DnnParameters​(int N,
                               int C,
                               int H,
                               int W,
                               int K,
                               int R,
                               int S,
                               int stride_h,
                               int stride_w,
                               int pad_h,
                               int pad_w,
                               int numThreads)

  - ### Method Detail

    - #### compare

          public boolean compare​(DnnParameters that)

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### setIfUnknown

          public void setIfUnknown​(Hop N,
                                   Hop C,
                                   Hop H,
                                   Hop W,
                                   Hop K,
                                   Hop R,
                                   Hop S,
                                   Hop stride_h,
                                   Hop stride_w,
                                   Hop pad_h,
                                   Hop pad_w,
                                   int numThreads)

    - #### isOutputThreadSafe

          public boolean isOutputThreadSafe()

    - #### isStride1Pad0

          public boolean isStride1Pad0()

    - #### isAllOnes

          public boolean isAllOnes​(Integer... params)